/*
 * Numerische Integration
 */

# include <stdio.h>
# include <math.h>

                 /* Zeiger auf Funktion als Parameter*/
double trapezFormel
  ( double, double, int, double (*)( double));
double polynom( double);

int main()
{
  double a, b, ( *f)( double);/* Zeiger auf Funktion */
  int n, Wahl;

  printf( "Funktion? (1: Sin, 2: Cos, 3: x^2+1)");
  scanf( "%d", &Wahl);
  switch ( Wahl)                  /* Adresszuweisung */
  {
    case 1: f = sin; break;    /* Standardfunktionen */
    case 2: f = cos; break;
    case 3: f = polynom; break;  /* Benutzerfunktion */
    default: printf( "Wahl unzulaessig!\n"); return -1;
  }

  printf( "Intervallgrenzen (untere obere)? ");
  scanf( "%lf%lf", &a, &b);

  printf(" Anzahl der Teilintervalle? ");
  scanf( "%d", &n);

  printf( "Integralwert: %g\n",
           trapezFormel( a, b, n, f));

  return 0;
}

/*
 * Funktion 'polynom'
 */
double polynom( double x)
{ return x * x + 1;
}

/*
 * Funktion 'trapezFormel'
 */
double trapezFormel
  ( double a, double b, int n, double (*f)(double))
{
  double s, h; int i;

  h = ( b - a) / n; s = 0.5 * ( f( a) + f ( b));
  for ( i = 0; i < n; i++) { a += h; s += f( a);}

  return s * h;
}
